/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 24 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:339  */

#include "api.h"
#include "lux.h"
#include "error.h"
#include "paramset.h"
#include "context.h"
#include "luxrays/core/color/color.h"
#include <stdarg.h>
#include <sstream>

using namespace lux;

extern int yylex(void);
u_int lineNum = 0;
string currentFile;

#define YYMAXDEPTH 100000000

void yyerror(const char *str)
{
	std::stringstream ss;
	ss << "Parsing error";
	if (currentFile != "")
		ss << " in file '" << currentFile << "'";
	if (lineNum > 0)
		ss << " at line " << lineNum;
	ss << ": " << str;
	LOG(LUX_SEVERE,LUX_SYNTAX)<< ss.str().c_str();
}

class ParamListElem {
public:
	ParamListElem() : token(NULL), arg(NULL), size(0), textureHelper(false)
	{ }
	const char *token;
	void *arg;
	u_int size;
	bool textureHelper;
};
u_int curParamlistAllocated = 0;
u_int curParamlistSize = 0;
ParamListElem *curParamlists = NULL;

#define CPAL curParamlistAllocated
#define CPS curParamlistSize
#define CP curParamlists
#define CPT(__n) curParamlists[(__n)].token
#define CPA(__n) curParamlists[(__n)].arg
#define CPSZ(__n) curParamlists[(__n)].size
#define CPTH(__n) curParamlists[(__n)].textureHelper

class ParamArray {
public:
	ParamArray() : elementSize(0), allocated(0), nelems(0), array(NULL) { }
	u_int elementSize;
	u_int allocated;
	u_int nelems;
	void *array;
};

ParamArray *curArray = NULL;
bool arrayIsSingleString = false;

#define NA(r) ((float *) r->array)
#define SA(r) ((const char **) r->array)

void AddArrayElement(void *elem)
{
	if (curArray->nelems >= curArray->allocated) {
		curArray->allocated = 2 * curArray->allocated + 1;
		curArray->array = realloc(curArray->array,
			curArray->allocated * curArray->elementSize);
	}
	char *next = static_cast<char *>(curArray->array) +
		curArray->nelems * curArray->elementSize;
	memcpy(next, elem, curArray->elementSize);
	curArray->nelems++;
}

ParamArray *ArrayDup(ParamArray *ra)
{
	ParamArray *ret = new ParamArray;
	ret->elementSize = ra->elementSize;
	ret->allocated = ra->allocated;
	ret->nelems = ra->nelems;
	ret->array = malloc(ra->nelems * ra->elementSize);
	memcpy(ret->array, ra->array, ra->nelems * ra->elementSize);
	return ret;
}

void ArrayFree(ParamArray *ra)
{
	free(ra->array);
	delete ra;
}

void FreeArgs()
{
	for (u_int i = 0; i < CPS; ++i) {
		// NOTE - Ratow - freeing up strings inside string type args
		if (memcmp("string", CPT(i), 6) == 0 ||
			memcmp("texture", CPT(i), 7) == 0) {
			for (u_int j = 0; j < CPSZ(i); ++j)
				free(static_cast<char **>(CPA(i))[j]);
		}
		delete[] static_cast<char *>(CPA(i));
	}
}

static bool VerifyArrayLength(ParamArray *arr, u_int required,
	const char *command)
{
	if (arr->nelems != required) {
		LOG( LUX_SEVERE,LUX_SYNTAX)
			<< command << " requires a(n) "
			<< required << " element array!";
		return false;
	}
	return true;
}
static void InitParamSet(ParamSet &ps, u_int count, ParamListElem *list);
#define YYPRINT(file, type, value)  \
{ \
	if ((type) == ID || (type) == STRING) \
		fprintf((file), " %s", (value).string); \
	else if ((type) == NUM) \
		fprintf((file), " %f", (value).num); \
}

#line 196 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "luxparse.hpp".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_LUXRENDER_LUX_B3F85CF7742F_LUXPARSE_HPP_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_LUXRENDER_LUX_B3F85CF7742F_LUXPARSE_HPP_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    STRING = 258,
    ID = 259,
    NUM = 260,
    LBRACK = 261,
    RBRACK = 262,
    ACCELERATOR = 263,
    AREALIGHTSOURCE = 264,
    ATTRIBUTEBEGIN = 265,
    ATTRIBUTEEND = 266,
    CAMERA = 267,
    CONCATTRANSFORM = 268,
    COORDINATESYSTEM = 269,
    COORDSYSTRANSFORM = 270,
    EXTERIOR = 271,
    FILM = 272,
    IDENTITY = 273,
    INTERIOR = 274,
    LIGHTSOURCE = 275,
    LOOKAT = 276,
    MATERIAL = 277,
    MAKENAMEDMATERIAL = 278,
    MAKENAMEDVOLUME = 279,
    MOTIONBEGIN = 280,
    MOTIONEND = 281,
    NAMEDMATERIAL = 282,
    OBJECTBEGIN = 283,
    OBJECTEND = 284,
    OBJECTINSTANCE = 285,
    PORTALINSTANCE = 286,
    MOTIONINSTANCE = 287,
    LIGHTGROUP = 288,
    PIXELFILTER = 289,
    RENDERER = 290,
    REVERSEORIENTATION = 291,
    ROTATE = 292,
    SAMPLER = 293,
    SCALE = 294,
    SEARCHPATH = 295,
    PORTALSHAPE = 296,
    SHAPE = 297,
    SURFACEINTEGRATOR = 298,
    TEXTURE = 299,
    TRANSFORMBEGIN = 300,
    TRANSFORMEND = 301,
    TRANSFORM = 302,
    TRANSLATE = 303,
    VOLUME = 304,
    VOLUMEINTEGRATOR = 305,
    WORLDBEGIN = 306,
    WORLDEND = 307,
    HIGH_PRECEDENCE = 308
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 154 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:355  */

char string[1024];
float num;
ParamArray *ribarray;

#line 296 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_LUXRENDER_LUX_B3F85CF7742F_LUXPARSE_HPP_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 313 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  88
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   144

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  73
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  156

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   308

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   178,   178,   182,   190,   195,   200,   204,   209,   213,
     219,   224,   228,   231,   235,   241,   245,   250,   255,   259,
     262,   266,   272,   276,   281,   285,   288,   305,   308,   312,
     319,   326,   330,   334,   341,   347,   351,   355,   359,   366,
     370,   374,   381,   388,   392,   399,   406,   413,   418,   422,
     426,   430,   434,   438,   442,   446,   453,   460,   464,   468,
     475,   479,   483,   490,   497,   504,   511,   515,   519,   525,
     529,   536,   543,   547
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "ID", "NUM", "LBRACK",
  "RBRACK", "ACCELERATOR", "AREALIGHTSOURCE", "ATTRIBUTEBEGIN",
  "ATTRIBUTEEND", "CAMERA", "CONCATTRANSFORM", "COORDINATESYSTEM",
  "COORDSYSTRANSFORM", "EXTERIOR", "FILM", "IDENTITY", "INTERIOR",
  "LIGHTSOURCE", "LOOKAT", "MATERIAL", "MAKENAMEDMATERIAL",
  "MAKENAMEDVOLUME", "MOTIONBEGIN", "MOTIONEND", "NAMEDMATERIAL",
  "OBJECTBEGIN", "OBJECTEND", "OBJECTINSTANCE", "PORTALINSTANCE",
  "MOTIONINSTANCE", "LIGHTGROUP", "PIXELFILTER", "RENDERER",
  "REVERSEORIENTATION", "ROTATE", "SAMPLER", "SCALE", "SEARCHPATH",
  "PORTALSHAPE", "SHAPE", "SURFACEINTEGRATOR", "TEXTURE", "TRANSFORMBEGIN",
  "TRANSFORMEND", "TRANSFORM", "TRANSLATE", "VOLUME", "VOLUMEINTEGRATOR",
  "WORLDBEGIN", "WORLDEND", "HIGH_PRECEDENCE", "$accept", "start",
  "array_init", "string_array_init", "num_array_init", "array",
  "string_array", "real_string_array", "single_element_string_array",
  "string_list", "string_list_entry", "num_array", "real_num_array",
  "single_element_num_array", "num_list", "num_list_entry", "paramlist",
  "paramlist_init", "paramlist_contents", "paramlist_entry",
  "ri_stmt_list", "ri_stmt", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308
};
# endif

#define YYPACT_NINF -140

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-140)))

#define YYTABLE_NINF -6

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      92,     6,     8,  -140,  -140,    10,  -140,    13,    14,    15,
      16,  -140,    17,    18,    21,    19,    25,    26,  -140,  -140,
      31,    32,  -140,    33,    36,    37,    38,    39,    40,  -140,
      41,    42,    43,    44,    46,    47,    48,    49,  -140,  -140,
    -140,    50,    51,    54,  -140,  -140,    58,    92,  -140,  -140,
    -140,  -140,    53,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -140,  -140,    55,  -140,  -140,    59,  -140,  -140,  -140,  -140,
    -140,    56,  -140,  -140,  -140,    60,  -140,    61,  -140,  -140,
    -140,  -140,    64,    53,  -140,    63,  -140,  -140,  -140,  -140,
    -140,    66,  -140,  -140,  -140,    65,  -140,  -140,  -140,    67,
    -140,  -140,  -140,    68,  -140,  -140,  -140,    69,  -140,    70,
    -140,  -140,  -140,    73,    72,  -140,  -140,  -140,  -140,    66,
      57,  -140,  -140,    76,  -140,    75,    77,  -140,  -140,  -140,
       0,  -140,  -140,  -140,  -140,  -140,  -140,  -140,  -140,    78,
    -140,  -140,  -140,    79,    82,  -140,    81,    80,  -140,  -140,
      83,  -140,  -140,    84,    85,  -140
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,    31,    32,     0,     3,     0,     0,     0,
       0,    39,     0,     0,     0,     0,     0,     0,     3,    48,
       0,     0,    51,     0,     0,     0,     0,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,    66,    67,
       3,     0,     0,     0,    72,    73,     0,     2,    28,    23,
      23,    23,     5,    34,    15,    16,    35,    36,    37,    23,
      40,    23,     0,    23,    23,     0,    47,    49,    50,    52,
      53,     0,    23,    23,    23,     0,    23,     0,    61,    23,
      23,    23,     0,     0,    68,     0,    23,    23,     1,    27,
      29,    25,    30,    33,     5,     0,    18,    38,    42,     0,
      44,    45,    23,     0,    41,    55,    56,     0,    59,     0,
      63,    62,    64,     0,     0,    71,    70,     3,    22,    25,
       5,    20,    21,     0,    46,     0,     0,    60,    23,    69,
       4,    26,     6,     8,     9,     7,    24,    17,    19,     0,
      54,    58,    65,     4,     0,    11,     0,     4,    13,    14,
       0,    10,    12,     0,     0,    43
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -140,  -140,   -37,  -140,  -140,  -140,  -140,  -140,  -140,  -140,
    -139,   -18,     4,  -140,  -140,   -87,   -49,  -140,   -56,  -140,
    -140,    24
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    46,    52,   144,    95,   131,   132,   133,   134,   147,
     145,    53,    54,    55,   120,    96,    90,    91,   118,   119,
      47,    48
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      66,    92,    93,    83,   148,    -5,   143,   121,   152,    49,
      97,    50,    98,    51,   100,   101,    56,    57,    58,    59,
      60,    61,    63,   104,   105,   106,    62,   108,    64,    65,
     110,   111,   112,   138,    67,    68,    69,   115,   116,    70,
      71,    72,    73,    74,    84,    76,    75,    78,    77,    79,
      80,    81,    82,   124,    86,    85,   121,    87,    88,    94,
      99,   103,   102,   136,   137,   107,   109,   113,   114,   117,
     122,    89,   123,   125,   126,   127,   128,   129,   140,   142,
     130,   139,   141,   146,    -5,   149,   150,   151,   153,   154,
     155,     0,     0,     0,     0,     0,     0,     0,     0,   135,
       1,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45
};

static const yytype_int16 yycheck[] =
{
      18,    50,    51,    40,   143,     5,     6,    94,   147,     3,
      59,     3,    61,     3,    63,    64,     3,     3,     3,     3,
       3,     3,     3,    72,    73,    74,     5,    76,     3,     3,
      79,    80,    81,   120,     3,     3,     3,    86,    87,     3,
       3,     3,     3,     3,    40,     3,     5,     3,     5,     3,
       3,     3,     3,   102,     3,     5,   143,     3,     0,     6,
       5,     5,     3,   119,     7,     5,     5,     3,     5,     3,
       5,    47,     5,     5,     5,     5,     3,     5,     3,   128,
     117,     5,     5,     5,     5,     3,     5,     7,     5,     5,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    55,    74,    75,     3,
       3,     3,    56,    65,    66,    67,     3,     3,     3,     3,
       3,     3,     5,     3,     3,     3,    65,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     3,     5,     3,     3,
       3,     3,     3,    56,    66,     5,     3,     3,     0,    75,
      70,    71,    70,    70,     6,    58,    69,    70,    70,     5,
      70,    70,     3,     5,    70,    70,    70,     5,    70,     5,
      70,    70,    70,     3,     5,    70,    70,     3,    72,    73,
      68,    69,     5,     5,    70,     5,     5,     5,     3,     5,
      56,    59,    60,    61,    62,    65,    72,     7,    69,     5,
       3,     5,    70,     6,    57,    64,     5,    63,    64,     3,
       5,     7,    64,     5,     5,     5
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    54,    55,    56,    57,    58,    59,    59,    60,    60,
      61,    62,    63,    63,    64,    65,    65,    66,    67,    68,
      68,    69,    70,    71,    72,    72,    73,    74,    74,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     0,     0,     1,     1,     1,     1,
       4,     2,     2,     1,     2,     1,     1,     4,     2,     2,
       1,     2,     2,     0,     2,     0,     2,     2,     1,     3,
       3,     1,     1,     3,     2,     2,     2,     2,     3,     1,
       2,     3,     3,    10,     3,     3,     4,     2,     1,     2,
       2,     1,     2,     2,     5,     3,     3,     1,     5,     3,
       4,     2,     3,     3,     3,     5,     1,     1,     2,     4,
       3,     3,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 179 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1503 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 3:
#line 183 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	if (curArray)
		ArrayFree(curArray);
	curArray = new ParamArray;
	arrayIsSingleString = false;
}
#line 1514 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 4:
#line 191 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	curArray->elementSize = sizeof(const char *);
}
#line 1522 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 5:
#line 196 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	curArray->elementSize = sizeof(float);
}
#line 1530 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 6:
#line 201 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 1538 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 7:
#line 205 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 1546 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 8:
#line 210 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 1554 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 9:
#line 214 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = ArrayDup(curArray);
	arrayIsSingleString = true;
}
#line 1563 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 10:
#line 220 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = ArrayDup(curArray);
}
#line 1571 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 11:
#line 225 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1578 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 12:
#line 229 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1585 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 13:
#line 232 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1592 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 14:
#line 236 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	char *toAdd = strdup((yyvsp[0].string));
	AddArrayElement(&toAdd);
}
#line 1601 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 15:
#line 242 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = (yyvsp[0].ribarray);
}
#line 1609 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 16:
#line 246 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = ArrayDup(curArray);
}
#line 1617 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 17:
#line 251 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	(yyval.ribarray) = ArrayDup(curArray);
}
#line 1625 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 18:
#line 256 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1632 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 19:
#line 260 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1639 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 20:
#line 263 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1646 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 21:
#line 267 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	float toAdd = (yyvsp[0].num);
	AddArrayElement(&toAdd);
}
#line 1655 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 22:
#line 273 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1662 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 23:
#line 277 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	CPS = 0;
}
#line 1670 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 24:
#line 282 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1677 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 25:
#line 285 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1684 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 26:
#line 289 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	void *arg = new char[(yyvsp[0].ribarray)->nelems * (yyvsp[0].ribarray)->elementSize];
	memcpy(arg, (yyvsp[0].ribarray)->array, (yyvsp[0].ribarray)->nelems * (yyvsp[0].ribarray)->elementSize);
	if (CPS >= CPAL) {
		CPAL = 2 * CPAL + 1;
		CP = static_cast<ParamListElem *>(realloc(CP,
			CPAL * sizeof(ParamListElem)));
	}
	CPT(CPS) = (yyvsp[-1].string);
	CPA(CPS) = arg;
	CPSZ(CPS) = (yyvsp[0].ribarray)->nelems;
	CPTH(CPS) = arrayIsSingleString;
	++CPS;
	ArrayFree((yyvsp[0].ribarray));
}
#line 1704 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 27:
#line 306 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1711 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 28:
#line 309 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
}
#line 1718 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 29:
#line 313 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Accelerator((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1729 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 30:
#line 320 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->AreaLightSource((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1740 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 31:
#line 327 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxAttributeBegin();
}
#line 1748 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 32:
#line 331 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxAttributeEnd();
}
#line 1756 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 33:
#line 335 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Camera((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1767 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 34:
#line 342 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	if (VerifyArrayLength((yyvsp[0].ribarray), 16, "ConcatTransform"))
		luxConcatTransform(static_cast<float *>((yyvsp[0].ribarray)->array));
	ArrayFree((yyvsp[0].ribarray));
}
#line 1777 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 35:
#line 348 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxCoordinateSystem((yyvsp[0].string));
}
#line 1785 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 36:
#line 352 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxCoordSysTransform((yyvsp[0].string));
}
#line 1793 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 37:
#line 356 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	Context::GetActive()->Exterior((yyvsp[0].string));
}
#line 1801 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 38:
#line 360 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Film((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1812 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 39:
#line 367 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxIdentity();
}
#line 1820 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 40:
#line 371 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	Context::GetActive()->Interior((yyvsp[0].string));
}
#line 1828 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 41:
#line 375 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->LightGroup((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1839 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 42:
#line 382 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->LightSource((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1850 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 43:
#line 389 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxLookAt((yyvsp[-8].num), (yyvsp[-7].num), (yyvsp[-6].num), (yyvsp[-5].num), (yyvsp[-4].num), (yyvsp[-3].num), (yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num));
}
#line 1858 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 44:
#line 393 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Material((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1869 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 45:
#line 400 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->MakeNamedMaterial((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1880 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 46:
#line 407 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->MakeNamedVolume((yyvsp[-2].string), (yyvsp[-1].string), params);
	FreeArgs();
}
#line 1891 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 47:
#line 414 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxMotionBegin((yyvsp[0].ribarray)->nelems, static_cast<float *>((yyvsp[0].ribarray)->array));
	ArrayFree((yyvsp[0].ribarray));
}
#line 1900 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 48:
#line 419 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxMotionEnd();
}
#line 1908 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 49:
#line 423 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	Context::GetActive()->NamedMaterial((yyvsp[0].string));
}
#line 1916 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 50:
#line 427 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxObjectBegin((yyvsp[0].string));
}
#line 1924 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 51:
#line 431 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxObjectEnd();
}
#line 1932 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 52:
#line 435 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxObjectInstance((yyvsp[0].string));
}
#line 1940 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 53:
#line 439 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxPortalInstance((yyvsp[0].string));
}
#line 1948 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 54:
#line 443 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxMotionInstance((yyvsp[-3].string), (yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].string));
}
#line 1956 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 55:
#line 447 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->PixelFilter((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1967 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 56:
#line 454 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Renderer((yyvsp[-1].string), params);
	FreeArgs();
}
#line 1978 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 57:
#line 461 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxReverseOrientation();
}
#line 1986 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 58:
#line 465 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxRotate((yyvsp[-3].num), (yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num));
}
#line 1994 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 59:
#line 469 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Sampler((yyvsp[-1].string), params);
	FreeArgs();
}
#line 2005 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 60:
#line 476 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxScale((yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num));
}
#line 2013 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 61:
#line 480 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	;//luxSearchPath($2);//FIXME - Unimplemented
}
#line 2021 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 62:
#line 484 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Shape((yyvsp[-1].string), params);
	FreeArgs();
}
#line 2032 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 63:
#line 491 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->PortalShape((yyvsp[-1].string), params);
	FreeArgs();
}
#line 2043 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 64:
#line 498 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->SurfaceIntegrator((yyvsp[-1].string), params);
	FreeArgs();
}
#line 2054 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 65:
#line 505 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Texture((yyvsp[-3].string), (yyvsp[-2].string), (yyvsp[-1].string), params);
	FreeArgs();
}
#line 2065 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 66:
#line 512 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxTransformBegin();
}
#line 2073 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 67:
#line 516 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxTransformEnd();
}
#line 2081 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 68:
#line 520 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	if (VerifyArrayLength((yyvsp[0].ribarray), 16, "Transform"))
		luxTransform(static_cast<float *>((yyvsp[0].ribarray)->array));
	ArrayFree((yyvsp[0].ribarray));
}
#line 2091 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 69:
#line 526 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxTranslate((yyvsp[-2].num), (yyvsp[-1].num), (yyvsp[0].num));
}
#line 2099 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 70:
#line 530 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->VolumeIntegrator((yyvsp[-1].string), params);
	FreeArgs();
}
#line 2110 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 71:
#line 537 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	ParamSet params;
	InitParamSet(params, CPS, CP);
	Context::GetActive()->Volume((yyvsp[-1].string), params);
	FreeArgs();
}
#line 2121 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 72:
#line 544 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxWorldBegin();
}
#line 2129 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;

  case 73:
#line 548 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1646  */
    {
	luxWorldEnd();
}
#line 2137 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
    break;


#line 2141 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/luxparse.cpp" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 551 "/builddir/build/BUILD/luxrender-lux-b3f85cf7742f/core/luxparse.y" /* yacc.c:1906  */

static void InitParamSet(ParamSet &ps, u_int count, ParamListElem *list) {
	ps.Clear();
	for (u_int i = 0; i < count; ++i) {
		ParamType type;
		string name;
		if (!LookupType(list[i].token, &type, name)) {
			LOG( LUX_WARNING,LUX_SYNTAX)
				<< "Type of parameter '" << list[i].token << "' is unknown";
			continue;
		}
		if (list[i].textureHelper && type != PARAM_TYPE_TEXTURE &&
			type != PARAM_TYPE_STRING) {
			LOG( LUX_WARNING,LUX_SYNTAX)
				<< "Bad type for " << name << ". Changing it to a texture.";
			type = PARAM_TYPE_TEXTURE;
		}
		void *data = list[i].arg;
		u_int nItems = list[i].size;
		if (type == PARAM_TYPE_INT) {
			// parser doesn't handle ints, so convert from floats
			int *idata = new int[nItems];
			float *fdata = static_cast<float *>(data);
			for (u_int j = 0; j < nItems; ++j)
				idata[j] = static_cast<int>(fdata[j]);
			ps.AddInt(name, idata, nItems);
			delete[] idata;
		} else if (type == PARAM_TYPE_BOOL) {
			// strings -> bools
			bool *bdata = new bool[nItems];
			for (u_int j = 0; j < nItems; ++j) {
				string s(*static_cast<const char **>(data));
				if (s == "true")
					bdata[j] = true;
				else if (s == "false")
					bdata[j] = false;
				else {
					LOG( LUX_WARNING,LUX_SYNTAX)
						<< "Value '" << s << "' unknown for boolean parameter '" <<
						list[i].token << "'. Using 'false'.";
					bdata[j] = false;
				}
			}
			ps.AddBool(name, bdata, nItems);
			delete[] bdata;
		} else if (type == PARAM_TYPE_FLOAT) {
			ps.AddFloat(name, static_cast<float *>(data), nItems);
		} else if (type == PARAM_TYPE_POINT) {
			ps.AddPoint(name, static_cast<Point *>(data), nItems / 3);
		} else if (type == PARAM_TYPE_VECTOR) {
			ps.AddVector(name, static_cast<Vector *>(data), nItems / 3);
		} else if (type == PARAM_TYPE_NORMAL) {
			ps.AddNormal(name, static_cast<Normal *>(data), nItems / 3);
		} else if (type == PARAM_TYPE_COLOR) {
			ps.AddRGBColor(name, static_cast<RGBColor *>(data), nItems / COLOR_SAMPLES);
		} else if (type == PARAM_TYPE_STRING) {
			string *strings = new string[nItems];
			for (u_int j = 0; j < nItems; ++j)
				strings[j] = string(static_cast<const char **>(data)[j]);
			ps.AddString(name, strings, nItems);
			delete[] strings;
		} else if (type == PARAM_TYPE_TEXTURE) {
			if (nItems == 1) {
				string val(*static_cast<const char **>(data));
				ps.AddTexture(name, val);
			} else {
				LOG( LUX_ERROR,LUX_SYNTAX) << "Only one string allowed for 'texture' parameter " << name;
			}
		}
	}
}
